% function x2n=midsample(x1,x2,x3,W12,W23,b2,b3,v1,v2,v3,NL);
% sample from middle layer given top and bottom layers

function x2n=midsample(x1,x2,x3,W12,W23,b2,b3,v1,v2,v3,NL);

tiny=exp(-700);

n2=length(x2);

x2r=rect(x2,1);
x1r=rect(x1,NL);

for j=1:n2,

  % top down mean and var 
  mua=W12(j,:)*x1r+b2(j); % 18 % of time
  va=v2;
  
  % combine top down with bottom up 
  
  y=x3-W23*x2r-b3+W23(:,j)*x2r(j);
  
  vb=1/(1/va+W23(:,j)'*(W23(:,j)/v3));
  mub=vb*(mua/va+y'*(W23(:,j)/v3));    % 27% of time

  % if NL==1,
  samp=twogauss(mua,va,mub,vb); % 18% of time
  % elseif NL==3,
  % samp=threegauss(mua,va,mub,vb);
  % end;
      
  % update x2 and x2r
  x2(j)=samp;
  x2r(j)=rect(x2(j),1); % 27% of time
  
  % plot function
  
  plt=0;
  if plt==1,  
    pneg=1/sqrt(2*pi*vn)*exp(-(mun^2)/(2*vn));
    ppos=1/sqrt(2*pi*vp)*exp(-(mup^2)/(2*vp));
    alpha=(ppos+tiny)/(ppos+pneg+2*tiny); % weight of negative portion
    qq=-3:0.01:3;
    qqn=alpha/sqrt(2*pi*va)*exp(-((qq-mua).^2/(2*va)));
    qqp=(1-alpha)/sqrt(2*pi*vb)*exp(-((qq-mub).^2/(2*vb)));
    plot(qq,qqn.*(qq<0)+qqp.*(qq>=0),'r');  grid;  drawnow;
  end;

end;

x2n=x2;